#!/bin/bash

# 获取tomcat进程ID
TomcatID=$(ps -ef | grep tomcat | grep '/bin/java' | grep -v grep | awk '{print $2}')

# tomcat启动程序(这里注意tomcat实际安装的路径)
StartTomcat=/usr/local/tomcat/bin/startup.sh
TomcatCache=/usr/local/tomcat/work/*
TomcatTemp=/usr/local/tomcat/temp/*

#定义要监控的页面地址
WebUrl=http://192.68.10.20:8080

#日志输出
GetPageInfo=/usr/local/tomcat/logs/TomcatMonitor.Info
TomcatMonitorLog=/usr/local/tomcat/logs/TomcatMonitor.log

Monitor()
{
    echo "[info]开始监控tomcat...[$(date +'%F %H:%M:%S')]"
    if [ $TomcatID ];then #这里判断Tomcat进程是否存在
        echo "[info]当前tomcat进程ID为:$TomcatID,继续检测页面..."
        # 检测是否启动成功(成功的话页面会返回状态"200")
        TomcatServiceCode=$(curl -s -o $GetPageInfo -m 10 --connect-timeout 10 $WebUrl -w %{http_code})
        if [ $TomcatServiceCode -eq 200 ];then
            echo "[info]页面返回码为$TomcatServiceCode，tomcat启动成功，测试页面正常"
        else
            echo "[error]tomcat页面出错，请注意...状态码为$TomcatServiceCode，错误日志已输出到$GetPageInfo"
            echo "[error]页面访问出错，开始重启tomcat"
            kill -9 $TomcatID # 杀掉原tomcat进程
            sleep 3
            rm -rf $TomcatCache # 清理tomcat缓存
	    rm -rf $TomcatTemp
            $StartTomcat
        fi
    else    
        echo "[error]tomcat进程不存在!tomcat开始自动重启..."
        echo "[info]$StartTomcat，请稍候..."
        rm -rf $TomcatCache
	rm -rf $TomcatTemp
        $StartTomcat
    fi
    echo "--------------------------"
}
Monitor>>$TomcatMonitorLog